<template>
  <div class="item">
    <div
      class="field field-checkbox"
      :class="{'no-active': !item.mainSwitch}">
      <div class="ui checkbox">
        <input
          type="checkbox"
          :name="'setting-'+item.notificationType.code"
          :id="'setting-'+item.notificationType.code"
          @change="checkboxChanged($event, index)"
          :checked="item.mainSwitch">
        <label
          :for="'setting-'+item.notificationType.code">
          <span>{{ item.notificationType.name }}</span>
          <div
            v-if="getHelptext(item)"
            class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: `<div><p>${getHelptext(item)}</p></div>`,
            }"/>
          </div>
        </label>
      </div>
    </div>
    <div
      v-if="item.notificationType.code !== 'i.notification_type.chat'"
      class="block-mail">
      <div
        class="field field-mail"
        :class="{'no-active': !item.mainMail}">
        <div class="mail-main desktopshow">{{ auth.username }}</div>
        <div class="ui toggle checkbox">
          <input
            type="checkbox"
            :name="'mainMail-'+item.notificationType.code"
            :id="'mainMail-'+item.notificationType.code"
            :checked="item.mainMail"
            @change="innerCheckboxChanged($event, index, 'mainMail')">
          <label :for="'mainMail-'+item.notificationType.code">
            <span class="mobilshow">{{ auth.username }}</span>
          </label>
        </div>
      </div>
      <div
        class="field field-mail-other"
        :class="{'no-active': !item.additionalMailSwitch, invalid: validation.hasError('item.additionalMailValue')}">
        <div
          class="error message"
          v-if="validation.hasError('item.additionalMailValue')">
          {{ validation.firstError('item.additionalMailValue') }}
        </div>
        <div class="ui input">
          <input
            type="text"
            placeholder="Дополнительные e-mail через запятую"
            v-model="item.additionalMailValue" >
        </div>
        <div class="ui toggle checkbox">
          <input
            type="checkbox"
            :name="'mailother-'+item.notificationType.code"
            :id="'mailother-'+item.notificationType.code"
            :checked="item.additionalMailSwitch"
            @change="innerCheckboxChanged($event, index, 'additionalMailSwitch')">
          <label :for="'mailother-'+item.notificationType.code">
            <span class="mobilshow">Дополнительный e-mail</span>
          </label>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import SimpleVueValidation from 'simple-vue-validator';
import { createNamespacedHelpers } from 'vuex';

const SimpleVueValidator = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
    email: 'Введите корректный E-mail.',
  },
});
const STORE_USER = createNamespacedHelpers('user');
export default {
  name: 'NotificationItem',
  props: {
    item: {
      type: Object,
      default() {
        return {};
      },
    },
    index: {
      type: Number,
      default: 0,
    },
  },
  data() {
    return {
      validable: this.item.additionalMailSwitch,
      errors: [],
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
  },
  validators: {
    'item.additionalMailValue'(value) {
      return SimpleVueValidator.value(value).custom(() => {
        if (this.item.notificationType.code === 'i.notification_type.chat') {
          return false;
        }

        if (!value && this.validable) {
          return 'Поле обязательно к заполнению.';
        }
        const emails = value.split(',');
        const err = [];
        emails.forEach((el) => {
          el = el.trim();
          // eslint-disable-next-line no-underscore-dangle
          if (SimpleVueValidator.value(el).email()._messages.length > 0) {
            err.push('error');
          }
        });
        if (err.length > 0 && this.validable) {
          return 'Введите корректный E-mail.';
        }

        return false;
      });
    },
  },
  watch: {
    'item.additionalMailSwitch'(val) {
      if (val) {
        this.validable = true;
        this.validate();
      } else {
        this.reset();
        this.validable = false;
      }
    },
    'validation.errors'(val) {
      this.$emit('valid-additional', {
        notificationId: this.item.notificationId,
        hasError: Boolean(val[0]),
      });
    },
  },
  methods: {
    checkboxChanged(event, index) {
      const payload = {
        checked: event.target.checked,
        index,
      };
      this.$emit('checkbox-changed', payload);
    },
    innerCheckboxChanged(event, index, type) {
      const payload = {
        checked: event.target.checked,
        index,
        type,
      };
      this.$emit('inner-checkbox-changed', payload);
    },
    validate() {
      return this.$validate()
        .then(success => success && { 'item.additionalMailValue': this.item.additionalMailValue });
    },
    reset() {
      this.validation.reset();
    },
    getHelptext(item) {
      switch (item.notificationType.code) {
        case 'i.notification_type.chat':
          if (this.auth.isOrganization) {
            return 'Вам будут отправлены уведомления о получении новых сообщений<br>'
              + 'на адрес электронной почты вашего магазина, указанный в его профиле,<br>'
              + 'однако если в профиле магазина указан подтвержденный мобильный<br>'
              + 'телефон, то оповещения будут приходить в виде sms-сообщений';
          }
          return 'Вам будут отправлены уведомления о получении новых сообщений<br>'
            + 'на e-mail, однако если у вас в профиле указан мобильный телефон,<br/>'
            + 'то оповещения будут приходить в виде sms-сообщений';
        default:
          return null;
      }
    },
  },
};
</script>

<style scoped lang="scss">
  .item {
    display: flex;
    max-width: 100%;
    padding: 1rem 0;
    position: relative;
    border-bottom: 1px solid #c5d1d9;
    @media screen and (max-width: 980px) {
      flex-flow: column nowrap;
      justify-content: flex-start;
      align-items: flex-start;
      width: 100%;
    }
    @media screen and (min-width: 981px) {
      justify-content: flex-start;
      width: auto;
      flex-flow: column nowrap;
      align-items: start;
    }
    .error.message {
      @media screen and (min-width: 981px) {
        position: absolute;
        bottom: -16px;
        left: 48px;
      }
    }
    .block-mail {
      display: flex;
      .mail-main {
        font-size: 0.8125rem;
        line-height: 1.3;
        font-weight: 400;
        padding: 0.5rem 0;
      }
      @media screen and (max-width: 980px) {
        flex-flow: column nowrap;
        justify-content: flex-start;
        align-items: flex-start;
        width: 100%;
      }
      @media screen and (min-width: 981px) {
        flex-flow: column wrap;
        justify-content: flex-end;
        align-items: start;
        width: auto;
        margin-left: 17px;
      }
    }
    .field {
      display: flex;
      margin: 0;
      @media screen and (max-width: 980px) {
        flex-flow: column-reverse nowrap;
        justify-content: flex-start;
        align-items: flex-start;
        width: 100%;
        .ui.checkbox {
          margin-bottom: 1rem;
        }
      }
      @media screen and (min-width: 981px) {
        flex-flow: row nowrap;
        justify-content: flex-start;
        align-items: center;
        .ui.toggle.checkbox label {
          margin-left: 0.5rem;
        }
      }
      .ui.checkbox label {
        margin: 0;
        > span {
          color: inherit;
        }
      }

      &.no-active {
        .ui.checkbox label span,
        .ui.input,
        .mail-main {
          opacity: 0.5;
        }
      }

      &.field-checkbox {
        .ui.checkbox label {
          height: auto;
          font-weight: 500;
          line-height: 1.3;
          white-space: normal;
        }
        @media screen and (min-width: 981px) {
          .ui.checkbox label {
            font-size: 0.875rem;
          }
        }
      }
      &.field-mail {
        width: auto;
        @media screen and (min-width: 981px) {
          flex-direction: row-reverse;

        }
      }
      &.field-mail-other {
        @media screen and (min-width: 981px) {
          position: relative;
          width: 22rem;
          flex-direction: row-reverse;
          .ui.input {
            width: calc(100% - 2.75rem);
          }
        }
      }
    }
  }

  .question {
    position: relative;
    display: inline-flex;
    > .button {
      display: inline-flex;
      justify-content: center;
      align-items: center;
      width: 1rem;
      height: 1rem;
      background: transparent;
      border: 1px solid #9badb9;
      border-radius: 50%;
      outline: 0;
      cursor: pointer;
      &:before {
        display: inline-flex;
        content: "?";
        font-size: 0.75rem;
        line-height: 1;
        color: #4272a4;
      }
    }
  }
</style>
